跳至主要内容

与 Svelte 集成

提示

本文假设您已熟悉 Svelte 的基本概念和模式。如需回顾,请参阅 Svelte 文档。

DHTMLX Pivot 可作为普通组件与 Svelte 集成。完整的可运行示例请参见 GitHub 上的 Svelte Pivot 演示。

创建项目​

信息

开始前请先安装 Node.js。Vite 为可选项。

以下命令将运行 Vite 项目脚手架工具,并允许您选择 Svelte 模板:

npm create vite@latest

将项目命名为 my-svelte-pivot-app。

安装依赖​

切换至新建的项目目录:

cd my-svelte-pivot-app

使用包管理器安装依赖并启动开发服务器:

yarn 
yarn start # 或:yarn dev
  • 使用 npm:
npm install
npm run dev

应用将在本地端口运行(例如 http://localhost:3000)。

创建 Pivot​

将 Pivot 包添加到项目中,然后将 Pivot 封装为 Svelte 组件。

第一步:安装包​

下载 Pivot 试用包 并按照 README 中的步骤操作。试用版 Pivot 包有效期为 30 天。

第二步:创建组件​

创建一个挂载 Pivot 的 Svelte 组件。新建文件 src/Pivot.svelte。

导入源文件​

打开 src/Pivot.svelte 并导入 Pivot 源文件。导入路径取决于包的版本:

  • PRO 版本(从本地文件夹安装):
Pivot.svelte
<script>
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';
</script>

如果包附带压缩资源,请将 pivot.css 替换为 pivot.min.css。

  • 试用版本:
Pivot.svelte
<script>
import { Pivot } from '@dhx/trial-pivot';
import '@dhx/trial-pivot/dist/pivot.css';
</script>

本教程使用 Pivot 的试用版本。

设置容器并挂载 Pivot​

要在页面上显示 Pivot,请添加一个容器 div,然后在 onMount 生命周期钩子中使用构造函数初始化 Pivot,并在 onDestroy 钩子中销毁 Pivot。

以下代码片段定义了一个最简 Pivot Svelte 组件:

Pivot.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

let container; // Pivot 的容器引用
let table;

onMount(() => {
// 初始化 Pivot 组件
table = new Pivot(container, {});
});

onDestroy(() => {
table.destructor(); // 卸载时销毁 Pivot
});
</script>

<div bind:this={container} class="widget"></div>

添加样式​

要使 Pivot 正确渲染,请将以下样式添加到项目的主 CSS 文件中:

main.css
/* 初始页面的样式 */
html,
body,
#app { /* 使用 #app 根容器 */
height: 100%;
padding: 0;
margin: 0;
}

/* Pivot 容器的样式 */
.widget {
height: 100%;
width: 100%;
}

加载数据​

要向 Pivot 传入数据,请准备一个数据集。创建 src/data.js 并导出数据和字段元数据:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // 其他数据项
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // 其他字段
];

return { dataset, fields };
};

打开 src/App.svelte,导入数据并将其作为 props 传递给新的 <Pivot/> 组件:

App.svelte
<script>
import Pivot from "./Pivot.svelte";
import { getData } from "./data.js";

const { fields, dataset } = getData();
</script>

<Pivot fields={fields} dataset={dataset} />

打开 src/Pivot.svelte,使用 export let 声明传入的 props,并将其应用到 Pivot 配置对象中:

Pivot.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export let fields;
export let dataset;

let container;
let table;

onMount(() => {
table = new Pivot(container, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 其他值
]
},
// 其他配置属性
});
});

onDestroy(() => {
table.destructor();
});
</script>

<div bind:this={container} class="widget"></div>

组件现已准备好使用。挂载时,Pivot 将使用所提供的数据进行渲染。完整的配置属性列表请参见 Pivot API 文档。

处理事件​

用户在 Pivot 中的操作会触发可订阅的事件。完整的事件列表请参见 事件概览。

以下代码片段在 onMount 中扩展了一个 open-filter 事件监听器,当用户打开筛选器时记录字段 ID:

Pivot.svelte
<script>
// ...
let table;

onMount(() => {
table = new Pivot(container, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 其他值
]
},
// 其他配置属性
});

table.api.on("open-filter", (ev) => {
console.log("激活筛选器的字段 id:", ev.id);
});
});

onDestroy(() => {
table.destructor();
});
</script>

// ...

启动应用,即可看到 Pivot 在页面上渲染数据。

在 Svelte 应用程序中渲染的 DHTMLX Pivot(含示例数据)

Pivot 现已与 Svelte 集成完成。您可以根据项目需求自定义配置。完整示例请参见 GitHub 上的 svelte-pivot-demo。

跳至主要内容

与 Angular 集成

提示

本文假设您已熟悉 Angular 的基本概念和使用模式。如需复习,请参阅 Angular 文档。

DHTMLX Pivot 可作为普通组件与 Angular 集成。完整的可运行示例请参见 GitHub 上的 Angular Pivot 演示。

创建项目​

信息

开始之前,请先安装 Angular CLI 和 Node.js。

以下命令将创建一个名为 my-angular-pivot-app 的新 Angular 项目:

ng new my-angular-pivot-app
备注

当 Angular CLI 询问时,请禁用服务器端渲染(SSR)和静态站点生成(SSG/Prerendering)。本指南假设使用客户端渲染应用。

该命令会安装所有必要的工具,无需执行其他命令。

安装依赖​

切换到新项目目录:

cd my-angular-pivot-app

使用 yarn 包管理器安装依赖并启动开发服务器:

yarn
yarn start # 或者:yarn dev

应用将在本地端口运行(例如 http://localhost:3000)。

创建 Pivot​

将 Pivot 包添加到项目中,然后将 Pivot 封装为 Angular 组件。

第一步:安装包​

下载 试用版 Pivot 包 并按照 README 中的步骤操作。试用版 Pivot 包有效期为 30 天。

第二步:创建组件​

创建一个用于挂载 Pivot 的 Angular 组件。在 src/app/ 下新建 pivot 文件夹,并创建 src/app/pivot/pivot.component.ts。然后按以下步骤操作:

导入源文件​

打开 src/app/pivot/pivot.component.ts 并导入 Pivot 包。导入路径取决于所使用的版本:

  • PRO 版本(从本地文件夹安装):
import { Pivot } from 'dhx-pivot-package';
  • 试用版本:
import { Pivot } from '@dhx/trial-pivot';

本教程使用 Pivot 的试用版本。

设置容器并挂载 Pivot​

要在页面上显示 Pivot,需在组件模板中定义一个容器元素,然后在 ngOnInit 钩子中使用构造函数初始化 Pivot,并在 ngOnDestroy 钩子中销毁 Pivot。

以下代码片段定义了一个最小化的 Pivot Angular 组件:

pivot.component.ts
import { Pivot } from '@dhx/trial-pivot';
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "pivot", // 模板名称,在 "app.component.ts" 文件中以 <pivot /> 形式使用
styleUrls: ["./pivot.component.css"], // 引入 CSS 文件
template: `<div #container className="widget"></div>`,
})

export class PivotComponent implements OnInit, OnDestroy {
// Pivot 的容器引用
@ViewChild('container', { static: true }) pivot_container!: ElementRef;

private _table!: Pivot;

ngOnInit() {
// 初始化 Pivot 组件
this._table = new Pivot(this.pivot_container.nativeElement, {});
}

ngOnDestroy(): void {
this._table.destructor(); // 卸载时销毁 Pivot
}
}

添加样式​

要正确渲染 Pivot,请创建 src/app/pivot/pivot.component.css,为页面和 Pivot 容器添加样式:

pivot.component.css
/* 导入 Pivot 样式 */
@import "@dhx/trial-pivot/dist/pivot.css";

/* 初始页面样式 */
html,
body {
margin: 0;
padding: 0;
height: 100%;
}

/* Pivot 容器样式 */
.widget {
width: 100%;
height: 100%;
}

加载数据​

要向 Pivot 提供数据,请准备数据集。创建 src/app/pivot/data.ts 并导出数据和字段元数据:

data.ts
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // 其他数据项
];

const fields: any = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // 其他字段
];

return { dataset, fields };
};

打开 src/app/pivot/pivot.component.ts,导入 getData,并在 ngOnInit() 中应用数据集:

pivot.component.ts
import { Pivot } from '@dhx/trial-pivot';
import { getData } from "./data"; // 导入数据
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: "pivot",
styleUrls: ["./pivot.component.css"],
template: `<div #container className="widget"></div>`,
})

export class PivotComponent implements OnInit, OnDestroy {
@ViewChild('container', { static: true }) pivot_container!: ElementRef;

private _table!: Pivot;

ngOnInit() {
const { dataset, fields } = getData(); // 解包数据和字段元数据
this._table = new Pivot(this.pivot_container.nativeElement, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 其他值
]
},
// 其他配置属性
});
}

ngOnDestroy(): void {
this._table.destructor();
}
}

组件现已可以使用。挂载时,Pivot 将使用提供的数据进行渲染。完整的配置属性列表请参见 Pivot API 文档。

处理事件​

用户在 Pivot 中的操作会触发相应事件,您可以对这些事件进行订阅。完整的事件列表请参见 事件概览。

以下代码片段在 ngOnInit 中扩展了一个 open-filter 事件监听器,当用户打开过滤器时记录字段 ID:

pivot.component.ts
// ...
ngOnInit() {
const { dataset, fields } = getData();
this._table = new Pivot(this.pivot_container.nativeElement, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 其他值
]
}
});

this._table.api.on("open-filter", (ev) => {
console.log("The field id for which the filter is activated:", ev.id);
});
}

ngOnDestroy(): void {
this._table.destructor();
}

第三步:将 Pivot 添加到应用​

要将 PivotComponent 嵌入应用,请打开 src/app/app.component.ts 并将默认代码替换为以下内容:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<pivot/>` // 在 "pivot.component.ts" 文件中创建的模板
})
export class AppComponent {
name = "";
}

然后创建 src/app/app.module.ts 并注册 PivotComponent:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { PivotComponent } from "./pivot/pivot.component";

@NgModule({
declarations: [AppComponent, PivotComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

最后,打开 src/main.ts 并将其内容替换为以下引导代码:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

启动应用,查看 Pivot 在页面上渲染数据的效果。

在 Angular 应用程序中渲染的 DHTMLX Pivot(含示例数据)

Pivot 现已与 Angular 集成完毕。您可以根据项目需求自定义配置。完整示例请参见 GitHub 上的 angular-pivot-demo。

跳至主要内容

与 Vue 集成

提示

本文假设您已具备 Vue 基本概念和模式的相关知识。如需复习,请参阅 Vue 3 文档。

DHTMLX Pivot 可作为普通组件与 Vue 集成。完整的工作示例请参见 GitHub 上的 Vue Pivot 演示。

创建项目​

信息

开始之前,请先安装 Node.js。

以下命令将运行官方的 Vue 项目脚手架工具:

npm create vue@latest

该命令会安装并执行 create-vue。详情请参阅 Vue.js 快速入门。

将项目命名为 my-vue-pivot-app。

安装依赖​

进入新建的项目目录:

cd my-vue-pivot-app

使用您的包管理器安装依赖并启动开发服务器:

yarn
yarn start # 或:yarn dev
  • 使用 npm:
npm install
npm run dev

应用将运行在本地端口上(例如 http://localhost:3000)。

创建 Pivot​

将 Pivot 包添加到项目中,然后将 Pivot 封装为一个 Vue 组件。

第一步:安装包​

下载 Pivot 试用包 并按照 README 中的步骤操作。Pivot 试用包有效期为 30 天。

第二步:创建组件​

创建一个用于挂载 Pivot 的 Vue 组件。新建文件 src/components/Pivot.vue。

导入源文件​

打开 src/components/Pivot.vue 并导入 Pivot 源文件。导入路径取决于所使用的包版本:

  • PRO 版本(从本地文件夹安装):
Pivot.vue
<script>
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';
</script>

如果包附带的是压缩资源,请导入 pivot.min.css 而非 pivot.css。

  • 试用版本:
Pivot.vue
<script>
import { Pivot } from '@dhx/trial-pivot';
import '@dhx/trial-pivot/dist/pivot.css';
</script>

本教程使用 Pivot 的试用版本。

设置容器并挂载 Pivot​

要在页面上显示 Pivot,需添加一个容器 div,然后在 mounted 钩子中使用构造函数初始化 Pivot,并在 unmounted 钩子中销毁 Pivot。

以下代码片段定义了一个最简化的 Pivot Vue 组件:

Pivot.vue
<script>
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default {
mounted() {
// 初始化 Pivot 组件
this.table = new Pivot(this.$refs.container, {});
},

unmounted() {
this.table.destructor(); // 卸载时销毁 Pivot
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

添加样式​

为确保 Pivot 正确渲染,请将以下样式添加到项目的主 CSS 文件中:

style.css
/* 初始页面的样式 */
html,
body,
#app { /* 使用 #app 根容器 */
height: 100%;
padding: 0;
margin: 0;
}

/* Pivot 容器的样式 */
.widget {
width: 100%;
height: 100%;
}

加载数据​

要向 Pivot 传入数据,需准备一个数据集。创建 src/data.js 并导出数据及字段元数据:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // 其他数据项
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // 其他字段
];

return { dataset, fields };
};

打开 src/App.vue,导入数据并通过 data() 选项暴露数据,然后将值作为 props 传递给新的 <Pivot/> 组件:

App.vue
<script>
import Pivot from "./components/Pivot.vue";
import { getData } from "./data";

export default {
components: { Pivot },
data() {
const { fields, dataset } = getData();
return {
fields,
dataset
};
}
};
</script>

<template>
<Pivot :fields="fields" :dataset="dataset" />
</template>

打开 src/components/Pivot.vue,声明传入的 props 并将其应用到 Pivot 配置对象中:

Pivot.vue
<script>
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default {
props: ["fields", "dataset"],

mounted() {
this.table = new Pivot(this.$refs.container, {
fields: this.fields,
data: this.dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 其他值
]
},
// 其他配置属性
});
},

unmounted() {
this.table.destructor();
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

组件现已可以使用。挂载后,Pivot 将使用所提供的数据进行渲染。完整的配置属性列表,请参阅 Pivot API 文档。

处理事件​

用户在 Pivot 中的操作会触发相应的事件,您可以订阅这些事件。完整的事件列表,请参阅事件概览。

以下代码片段在 mounted 中添加了一个 open-filter 事件监听器,当用户打开筛选器时,它会记录对应的字段 ID:

Pivot.vue
<script>
// ...
export default {
// ...
mounted() {
this.table = new Pivot(this.$refs.container, {
fields: this.fields,
data: this.dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 其他值
]
},
// 其他配置属性
});

this.table.api.on("open-filter", (ev) => {
console.log("激活筛选器的字段 id:", ev.id);
});
}
// ...
}
</script>

// ...

启动应用,即可看到 Pivot 在页面上渲染数据。

在 Vue 应用程序中渲染的 DHTMLX Pivot(含示例数据)

Pivot 现已与 Vue 完成集成。您可以根据项目需求自定义配置。完整示例请参见 GitHub 上的 vue-pivot-demo。

跳至主要内容

与 React 集成

提示

本文假定您已熟悉 React 的基本概念和模式。如需回顾,请参阅 React 文档。

DHTMLX Pivot 可作为普通组件与 React 集成。完整的示例项目请参见 GitHub 上的 React Pivot 演示。

创建项目​

信息

开始前请先安装 Node.js。Vite 为可选项。

创建一个名为 my-react-pivot-app 的基础 React 项目(或基于 Vite 的项目)。

以下命令可引导创建一个 Create React App 项目:

npx create-react-app my-react-pivot-app

安装依赖​

切换到新建的项目目录:

cd my-react-pivot-app

使用包管理器安装依赖并启动开发服务器:

yarn
yarn start # 或:yarn dev
  • 使用 npm:
npm install
npm run dev

应用将运行在本地端口(例如 http://localhost:3000)。

创建 Pivot​

将 Pivot 包添加到项目中,然后将 Pivot 封装在 React 组件内。

第一步:安装包​

下载 Pivot 试用包 并按照 README 中的步骤操作。试用包有效期为 30 天。

第二步:创建组件​

创建一个用于挂载 Pivot 的 React 组件。新建文件 src/Pivot.jsx。

导入源文件​

打开 src/Pivot.jsx 并导入 Pivot 源文件。导入路径取决于所使用的包版本:

  • PRO 版本(从本地文件夹安装):
Pivot.jsx
import { Pivot } from 'dhx-pivot-package';
import 'dhx-pivot-package/dist/pivot.css';

如果包中包含压缩资源,请导入 pivot.min.css 而非 pivot.css。

  • 试用版本:
Pivot.jsx
import { Pivot } from '@dhx/trial-pivot';
import "@dhx/trial-pivot/dist/pivot.css";

本教程使用 Pivot 的试用版本。

设置容器并挂载 Pivot​

要在页面上显示 Pivot,需创建一个容器 div,然后在 useEffect hook 中使用构造函数初始化 Pivot。

以下代码片段定义了一个最简的 Pivot React 组件:

Pivot.jsx
import { useEffect, useRef } from "react";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css"; // 引入 Pivot 样式

export default function PivotComponent(props) {
let container = useRef(); // Pivot 的容器 ref

useEffect(() => {
// 初始化 Pivot 组件
const table = new Pivot(container.current, {});

return () => {
table.destructor(); // 卸载时销毁 Pivot
};
}, []);

return <div ref={container} className="widget"></div>;
}

添加样式​

为使 Pivot 正确渲染,请将以下样式添加到项目的主 CSS 文件中:

index.css
/* 初始页面的样式 */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* Pivot 容器的样式 */
.widget {
height: 100%;
width: 100%;
}

加载数据​

要向 Pivot 传入数据,需准备一个数据集。创建 src/data.js 并导出数据和字段元数据:

data.js
export function getData() {
const dataset = [
{
"cogs": 51,
"date": "10/1/2018",
"inventory_margin": 503,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 46,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Lemon",
"profit": -5,
"sales": 122,
"state": "Colorado",
"expenses": 76,
"type": "Decaf"
},
{
"cogs": 52,
"date": "10/1/2018",
"inventory_margin": 405,
"margin": 71,
"market_size": "Major Market",
"market": "Central",
"marketing": 17,
"product_line": "Leaves",
"product_type": "Herbal Tea",
"product": "Mint",
"profit": 26,
"sales": 123,
"state": "Colorado",
"expenses": 45,
"type": "Decaf"
}, // 其他数据项
];

const fields = [
{
"id": "cogs",
"label": "Cogs",
"type": "number"
},
{
"id": "date",
"label": "Date",
"type": "date"
}, // 其他字段
];

return { dataset, fields };
};

打开 src/App.js,导入数据并将其作为 props 传递给 <Pivot/> 组件:

App.js
import Pivot from "./Pivot";
import { getData } from "./data";

function App() {
const { fields, dataset } = getData();
return <Pivot fields={fields} dataset={dataset} />;
}

export default App;

打开 src/Pivot.jsx,对 props 进行解构,并将其应用到 Pivot 的配置对象中:

Pivot.jsx
import { useEffect, useRef } from "react";
import { Pivot } from "@dhx/trial-pivot";
import "@dhx/trial-pivot/dist/pivot.css";

export default function PivotComponent({ fields, dataset }) {
let container = useRef();

useEffect(() => {
const table = new Pivot(container.current, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 其他值
]
},
// 其他配置属性
});

return () => {
table.destructor();
}
}, []);

return <div ref={container} className="widget"></div>;
}

组件现已可以使用。挂载时,Pivot 将使用传入的数据进行渲染。完整的配置属性列表,请参见 Pivot API 文档。

处理事件​

用户在 Pivot 中的操作会触发相应事件,您可以订阅这些事件。完整的事件列表,请参见事件概览。

以下代码片段在 useEffect 中扩展了一个 open-filter 事件监听器,当用户打开过滤器时记录字段 ID:

Pivot.jsx
// ...
useEffect(() => {
const table = new Pivot(container.current, {
fields,
data: dataset,
config: {
rows: ["state", "product_type"],
columns: ["product_line", "type"],
values: [
{
field: "profit",
method: "sum"
}, // 其他值
]
},
// 其他配置属性
});

table.api.on("open-filter", (ev) => {
console.log("激活过滤器的字段 id:", ev.id);
});

return () => {
table.destructor();
}
}, []);
// ...

启动应用,即可看到 Pivot 在页面上渲染数据。

在 React 应用程序中渲染的 DHTMLX Pivot(含示例数据)

Pivot 现已成功与 React 集成。可根据项目需求自定义配置。完整示例请参见 GitHub 上的 react-pivot-demo。